Bug 137816 - system does not boot with > 75 partitions (nash)
system does not boot with > 75 partitions (nash)
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: mkinitrd (Show other bugs)
3.0
All Linux
high Severity high
: ---
: ---
Assigned To: Peter Jones
David Lawrence
:
Depends On:
Blocks: 156321
  Show dependency treegraph
 
Reported: 2004-11-01 14:33 EST by David Lehman
Modified: 2010-10-21 22:40 EDT (History)
4 users (show)

See Also:
Fixed In Version: RHBA-2005-693
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-09-28 15:08:29 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch make nash read all of /proc/partitions even if it's huge (747 bytes, patch)
2004-11-01 14:33 EST, David Lehman
no flags Details | Diff
nash-short-reads-on-proc-partitions.patch (439 bytes, patch)
2005-08-24 08:33 EDT, Bastien Nocera
no flags Details | Diff

  None (edit)
Description David Lehman 2004-11-01 14:33:39 EST
Description of problem:
nash only calls read once on /proc/partitions. If the file is not read in it's
entirety (probably if '/' is listed after the bit slurped by the on read call)
the boot stops with the following output:
 ...
 Creating block devices
 VFS: Cannot open root device "LABEL=/" or 00:00
 Please append a correct "root=/" boot option
 Kernel panic: VFS: Unable to mount root fs on 00:00


Version-Release number of selected component (if applicable):
mkinitrd-3.5.13-1

How reproducible:
Always if you have > 75 partitions

Steps to Reproduce:
1. boot system with more than 75 partitions
2.
3.
  
Actual results:
system fails to boot

Expected results:
system boots successfully

Additional info:
Comment 1 David Lehman 2004-11-01 14:33:39 EST
Created attachment 106040 [details]
Patch make nash read all of /proc/partitions even if it's huge
Comment 2 Jeremy Katz 2004-11-03 18:03:57 EST
Committed a fix to CVS, but not this one exactly.  
Comment 4 Bastien Nocera 2005-08-24 08:33:06 EDT
The problem still occurs (but only if /proc/partitions is being read, rather
than a file copy of /proc/partitions).
We can have short reads reading /proc/partitions when loads of disks are
present, and only the first line would be read in the first go.

The attached patch fixes the problem with short-reads by retrying to read the
file until there's absolutely nothing else to read.
The problem can be reproduced easily by creating loads of partitions in a VMWare
instance (could also be replicated with a real machine with loads of disks, but
setting up VMWare is just easier in that case).
Comment 5 Bastien Nocera 2005-08-24 08:33:56 EDT
Created attachment 118053 [details]
nash-short-reads-on-proc-partitions.patch
Comment 10 Peter Jones 2005-09-01 17:02:09 EDT
Can you try the mkinitrd-3.5.13.6-1 packages here:

http://people.redhat.com/pjones/mkinitrd/rhel3/

Thanks.
Comment 19 Red Hat Bugzilla 2005-09-28 15:08:29 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2005-693.html

Note You need to log in before you can comment on or make changes to this bug.